
-- this is the may game physics function.
-- It is usually called from love:update()
-- Here we call every other function for the
-- game physics and perform general operations.

-- WARNING, EVERYTHING DONE HERE COULD BE PRETTY HEAVY
-- WHEN THERE ARE MANY OBJECTS CREATED!!!!
function gamePhysics()
	-- check player collide enemy ship
	if playerHasCrashed == false then
		for i,v in ipairs(enemy) do
			if playerCollideEnemy(v.posX, v.posY, v.width, v.height) then
				-- PLAYER COLLIDED WITH ENEMY SHIP
				-- I don't like to use this, but for the sake
				-- of efficiency, just get outa here if we already found a
				-- candidate.
				-- Later on I will implement a "playerHasCrashed" method.
				-- This method will check if the player is crashing with the
				-- same enemy, and if not, the collissions from start.
				-- But if the player is crashing with the same enemy (passed through parameters)
				-- then we no check every collision again!!!!
				playerHasCrashed = true
				previousCrash["x"] = v.posX
				previousCrash["y"] = v.posY
				previousCrash["w"] = v.width
				previousCrash["h"] = v.height
				break
			end
		end
	else
		if not(playerCollideEnemy(previousCrash["x"], previousCrash["y"], previousCrash["w"], previousCrash["h"])) then
			playerHasCrashed = false
		end
	end
	
	-- check Player Bullet collided enemy ship
	for i,v in ipairs(bullet) do -- run through all player bullets
		for j,k in ipairs(enemy) do
			if bulletCollideEnemy(v.posX, v.posY, v.width, v.height, k.posX, k.posY, k.width, k.height) then
				-- PLAYER BULLET COLLIDES ENEMY
				bullet.remove(i)
				enemy.damage(k, 50)
			end
		end
	end
end

function playerCollideEnemy(bx1, by1, bw, bh)
	local ax2 = playerPosX + playerImage:getWidth()
	local ay2 = playerPosY + playerImage:getHeight()
	local bx2 = bx1 + bw
	local by2 = by1 + bh
	
	return not(ay2 <= by1 or playerPosY >= by2 or playerPosX >= bx2 or ax2 <= bx1)
end

function bulletCollideEnemy(ax1, ay1, aw, ah, bx1, by1, bw, bh)
	local ax2 = ax1 + aw
	local ay2 = ay1 + ah
	local bx2 = bx1 + bw
	local by2 = by1 + bh
	
	return not(ay2 <= by1 or ay1 >= by2 or ax1 >= bx2 or ax2 <= bx1)
end
